/*
 *  Copyright (C) 2012 Thomas Luka, 18 rue des feuilles mortes, 95 Vaureal
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
#ifndef HISTORY_H_INCLUDED
#define HISTORY_H_INCLUDED

#include <QtGui>
#include <QtCore>
#include <QApplication>
#include "giac.h"
#include "geo/output.h"
#include "evalthread.h"

using namespace giac;

class StandardItem;
class History : public QWidget
{
  Q_OBJECT

    public:

  History();
  ~History();
  void addCmd(const QString Cmd);
  void Evaluate();
  QStringList allCmds();
  void setAllItems(QStringList items);
  StandardItem* addItem(QString text, bool cmd);

  public slots:

  void changeCmd(const QModelIndex &index, const QModelIndex &indexDeux);
  void CopierClicked();
  void ClearClicked();
  void EvalError(QString s);
  void EvalFinished();
  void stop_calcul();
  void suite_calcul();
  void terminate_thread();

 signals:

  void strCpSignal(QString s);
  void calcul_en_cours(bool b);

 private:

  QListView *m_cmdView;
  QStandardItemModel *m_cmdModel;
  QVBoxLayout *m_LayoutWidget;
  QPushButton *m_Copier;
  QPushButton *m_Clear;
  EvalThread *m_thread;
  QList<StandardItem *> m_a_calculer;
  StandardItem *m_traitement;//Pour savoir quel calcul est traité

 public:
  giac::context * contextptr;

};

class StandardItem : public QStandardItem
{
 public:
  StandardItem(bool cmd);
  StandardItem(bool cmd,const QString & text);
  StandardItem(bool cmd,const QString & text,StandardItem *ans);
  void setAnsStandardItem(StandardItem *ans);
  StandardItem * ansStandardItem();
  bool isAns();
  bool isCmd();

 private:
  StandardItem *m_ans;
  bool m_isCmd;
};
#endif // HISTORY_H_INCLUDED
